package xyz.lychee.lagfixer.libs.adventure.text.event;

import java.util.function.UnaryOperator;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface HoverEventSource<V> {
   static <V> @Nullable HoverEvent<V> unbox(final @Nullable HoverEventSource<V> source) {
      return source != null ? source.asHoverEvent() : null;
   }

   default @NotNull HoverEvent<V> asHoverEvent() {
      return this.asHoverEvent(UnaryOperator.identity());
   }

   @NotNull HoverEvent<V> asHoverEvent(final @NotNull UnaryOperator<V> op);
}
